#include <iostream>

using namespace std;

int main()
{
    int t;
    cin >> t;
    for (int i=0; i<t; i++)
    {
        int ispis;
        int n;
        cin >> n;
        int b[n];
        int prvi[n];
        int sumaa=0;
        int sumab=0;
        int daa=1;
        int dab=1;
        for (int j=0; j<n; j++)
        {
            cin >> prvi[j];

            if (prvi[j]!=1 && prvi[j]!=-1)
                daa=0;
        }
        for (int j=0; j<n; j++)
        {
            cin >> b[j];
            if (b[j]!=0)
                sumab++;
            if (b[j]!=1 && b[j]!=-1)
                dab=0;
        }

        if ( sumab==n && dab==1)
        {
            int nega, negb;
            nega=0; negb=0;
            for (int j=0; j<n; j++)
            {
                if (prvi[j]==-1)
                    nega++;
                if (b[j]==-1)
                    negb++;
            }
            if ((nega-negb)%2==0)
                ispis=1;
            if ((nega-negb)%2==1)
                ispis=0;
        }

        if (sumab==1)
        {
            int mestoa, mestob;
            int broja, brojb;
            for (int j=0; j<n; j++)
            {
                if (prvi[j]!=0)
                {

                    mestoa=j;
                    broja=prvi[mestoa];
                }
                if (b[j]!=0)
                {
                    brojb=b[j];
                    mestob=j;
                }
            }
            if (broja==brojb && (mestoa-mestob)%2==0)
                ispis=1;
            if (broja==brojb && (mestoa-mestob)%2==1)
                ispis=0;
            if (broja=0-brojb && (mestoa-mestob)%2==0)
                ispis=0;
            if (broja=0-brojb && (mestoa-mestob)%2==1)
                ispis=1;
            if (broja!=brojb && broja!=0-brojb )
                ispis=0;

            //cout << mestoa << endl;
            //cout << mestob << endl;
            //cout << broja << endl;
            //cout << brojb << endl;
        }


        if(ispis==0)
            cout << "NE" << endl;
        if (ispis==1)
            cout << "DA" << endl;

    }
}